#include <Servo.h>
#include <stdio.h>
// Time variables
unsigned long startMillis;
unsigned long currentMillis;
int period = 25;

// Servo variables
Servo servoL;
Servo servoR;
int posA = 40;
int posB = 100;
int incrementA = 1;
int incrementB = -1;

int posAStart = 40;
int posAEnd = 100;

int posBStart = 0;
int posBEnd = 30;

int lower = posAStart;
int upper = posAEnd;

// int upperBound = upper;
// int lowerBound = lower;

// Piezo variables
int piezoPinA = 0;
int piezoPinB = 2;
int piezoPinA = 4;
int piezoPinB = 6;
int threshold = 50;

int valueA = 0;
int valueB = 0;

// LED Pin
int ledA = 12;
int ledB = 13;
int ledStatusA = HIGH;
int ledStatusB = HIGH;


void setup() {
  // put your setup code here, to run once:
  pinMode(ledA, OUTPUT); 
  pinMode(ledB, OUTPUT);
  servoL.attach(2);
  servoR.attach(4);
  Serial.begin(9600);
  startMillis = millis();
  digitalWrite(ledA, ledStatusA);
  digitalWrite(ledB, ledStatusB);
}

void loop() {
  // put your main code here, to run repeatedly:
  currentMillis = millis();
  
  if (currentMillis - startMillis >= period) {
    posA = setServo(posA, incrementA, lower, upper);
    servoL.write(posA);
    incrementA = updateIncrement(posA, lower, upper, incrementA);

    posB = setServo(posB, incrementB, lower, upper);
    servoR.write(posB);
    incrementB = updateIncrement(posB, lower, upper, incrementB);
//
//    whichLouder(lower, upper);


    startMillis = currentMillis;
  }
}

int setServo(int pos, int increment, int lowerBound, int upperBound) {
  if (pos > upperBound && upperBound == posBEnd)  {
    pos = upperBound;
  } else if (pos <= lowerBound && lowerBound == posAStart) {
    pos = lowerBound;
  }

  pos += increment;

  // if (pos == upperBound || pos == lowerBound) {
  //   increment = -1*increment;
  // }

  return pos;
}

int updateIncrement(int pos, int lowerBound, int upperBound, int increment) {
  if (pos == upperBound || pos == lowerBound) {
    increment = -1*increment;
  }

  return increment;
}

void whichLouder(int &newLow, int &newHigh) {
  valueA = analogRead(piezoPinA);
  valueB = analogRead(piezoPinB);

  if (valueA > valueB && valueA >= threshold) {
    // Serial.println("piezo A");
    // Serial.println(valueA);
    newLow = posAStart;
    newHigh = posAEnd;
  } else if (valueB > valueA && valueB >= threshold) {
    // Serial.println("piezo B");
    // Serial.println(valueB);
    newLow = posBStart;
    newHigh = posBEnd;
  } else {
    newLow = newLow;
    newHigh = newHigh;
  }
}
